package io.github.null2264.tsukumogami.bot.core.module

import dev.kord.core.entity.effectiveName
import io.github.null2264.tsukumogami.bot.core.module.arguments.Test2Arguments
import io.github.null2264.tsukumogami.bot.core.module.arguments.Test3Arguments
import io.github.null2264.tsukumogami.bot.core.module.arguments.TestArguments
import io.github.null2264.tsukumogami.core.module.api.botModules
import kotlinx.datetime.Clock

val generalModule = botModules("General") {
    commands("ping", alias = setOf("p"), description = "Ping the bot!") { ctx ->
        val startTime = Clock.System.now()
        ctx.typing()
        val endTime = Clock.System.now()
        ctx.send("Pong! ${endTime.toEpochMilliseconds() - startTime.toEpochMilliseconds()}ms")
    }

    groups("group") {
        commands("test", arguments = ::Test2Arguments) { ctx, args -> ctx.reply("Hello world ${args.user}") }
        groups("group") {
            commands("test", alias = setOf("t"), arguments = ::Test3Arguments) { ctx, args ->
                ctx.reply("URL: ${args.url}")
            }
        }
    }

    commands("test", arguments = ::TestArguments) { ctx, args -> ctx.send("Hello world ${args.test}") }
}
