package io.github.null2264.tsukumogami.core.commands.converters.impl

import io.github.null2264.tsukumogami.core.Context
import io.github.null2264.tsukumogami.core.commands.StringParser
import io.github.null2264.tsukumogami.core.commands.converters.Converter

class StringConverter : Converter<String>() {

    override var parsed: String = ""

    override suspend fun consume(context: Context, parser: StringParser): Boolean {
        if (!parser.hasNext()) return this.parsed.isEmpty()

        this.parsed = if (isGreedy) run {
            var buffer = ""
            var count = 0
            while (parser.hasNext()) {
                if (++count > 1) buffer += " "
                buffer += parser.parseNext(true)
            }
            buffer
        } else parser.parseNext()

        return this.parsed.isNotEmpty()
    }
}
